? diffs
? lb-filter.c
? lb-filter.h
? lb-interactive.c
? lb-interactive.h
? lb.patch
? leaks.patch
? pspp.list
? repeat.c,d
? sig.patch
? ss.patch
? doc/.dirstamp
? lib/gsl-extras/.deps
? lib/gsl-extras/.dirstamp
? lib/gtksheet/.deps
? lib/gtksheet/.dirstamp
? lib/linreg/.deps
? lib/linreg/.dirstamp
? m4/Makefile.am
? m4/codeset.m4
? m4/gettext.m4
? m4/glibc2.m4
? m4/glibc21.m4
? m4/iconv.m4
? m4/intdiv0.m4
? m4/intmax.m4
? m4/inttypes-pri.m4
? m4/inttypes.m4
? m4/inttypes_h.m4
? m4/isc-posix.m4
? m4/lcmessage.m4
? m4/lib-ld.m4
? m4/lib-link.m4
? m4/lib-prefix.m4
? m4/longdouble.m4
? m4/longlong.m4
? m4/nls.m4
? m4/po.m4
? m4/printf-posix.m4
? m4/progtest.m4
? m4/signed.m4
? m4/size_max.m4
? m4/stdint_h.m4
? m4/uintmax_t.m4
? m4/ulonglong.m4
? m4/wchar_t.m4
? m4/wint_t.m4
? m4/xsize.m4
? src/data/.deps
? src/data/.dirstamp
? src/language/.deps
? src/language/.dirstamp
? src/language/control/.deps
? src/language/control/.dirstamp
? src/language/data-io/.deps
? src/language/data-io/.dirstamp
? src/language/data-io/file-handle.c
? src/language/data-io/list.c
? src/language/dictionary/.deps
? src/language/dictionary/.dirstamp
? src/language/expressions/.deps
? src/language/expressions/.dirstamp
? src/language/lexer/.deps
? src/language/lexer/.dirstamp
? src/language/lexer/q2c
? src/language/stats/.deps
? src/language/stats/.dirstamp
? src/language/stats/correlations.c
? src/language/stats/crosstabs.c
? src/language/stats/examine.c
? src/language/stats/frequencies.c
? src/language/stats/means.c
? src/language/stats/oneway.c
? src/language/stats/rank.c
? src/language/stats/regression.c
? src/language/stats/t-test.c
? src/language/tests/.deps
? src/language/tests/.dirstamp
? src/language/utilities/.deps
? src/language/utilities/.dirstamp
? src/language/utilities/set.c
? src/language/xforms/.deps
? src/language/xforms/.dirstamp
? src/libpspp/.deps
? src/libpspp/.dirstamp
? src/libpspp/version.c
? src/math/.deps
? src/math/.dirstamp
? src/math/linreg/.deps
? src/math/linreg/.dirstamp
? src/math/ts/.deps
? src/math/ts/.dirstamp
? src/output/.deps
? src/output/.dirstamp
? src/output/charts/.deps
? src/output/charts/.dirstamp
? src/ui/.deps
? src/ui/.dirstamp
? src/ui/gui/.deps
? src/ui/gui/.dirstamp
? src/ui/gui/psppire
? src/ui/terminal/.deps
? src/ui/terminal/.dirstamp
? src/ui/terminal/pspp
? tests/formats/.deps
? tests/formats/.dirstamp
? tests/formats/inexactify
? tests/libpspp/.deps
? tests/libpspp/.dirstamp
? tests/libpspp/ll-test
? tests/libpspp/llx-test
Index: src/language/automake.mk
===================================================================
RCS file: /sources/pspp/pspp/src/language/automake.mk,v
retrieving revision 1.3
diff -b -w -U3 -r1.3 automake.mk
--- src/language/automake.mk	17 Mar 2006 00:41:57 -0000	1.3
+++ src/language/automake.mk	26 Nov 2006 05:09:04 -0000
@@ -13,8 +13,10 @@
 noinst_LIBRARIES += src/language/liblanguage.a 
 
 src_language_liblanguage_a_SOURCES = \
-	src/language/line-buffer.c \
-	src/language/line-buffer.h \
+	src/language/syntax-file.c \
+	src/language/syntax-file.h \
+	src/language/prompt.c \
+	src/language/prompt.h \
 	src/language/command.c \
 	src/language/command.h \
 	src/language/command.def 
Index: src/language/command.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/command.c,v
retrieving revision 1.19
diff -b -w -U3 -r1.19 command.c
--- src/language/command.c	11 Nov 2006 23:10:00 -0000	1.19
+++ src/language/command.c	26 Nov 2006 05:09:04 -0000
@@ -32,7 +32,7 @@
 #include <data/settings.h>
 #include <data/variable.h>
 #include <language/lexer/lexer.h>
-#include <language/line-buffer.h>
+#include <language/prompt.h>
 #include <libpspp/alloc.h>
 #include <libpspp/assertion.h>
 #include <libpspp/compiler.h>
@@ -162,7 +162,7 @@
   enum cmd_result result;
 
   /* Read the command's first token. */
-  getl_set_prompt_style (GETL_PROMPT_FIRST);
+  set_prompt_style (PROMPT_FIRST);
   set_completion_state (state);
   lex_get (lexer);
   if (lex_token (lexer) == T_STOP)
@@ -172,7 +172,7 @@
       /* Null commands can result from extra empty lines. */
       return CMD_SUCCESS; 
     }
-  getl_set_prompt_style (GETL_PROMPT_LATER);
+  set_prompt_style (PROMPT_LATER);
 
   /* Parse the command name. */
   command = parse_command_name (lexer);
Index: src/language/prompt.c
===================================================================
RCS file: src/language/prompt.c
diff -N src/language/prompt.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/language/prompt.c	26 Nov 2006 05:09:04 -0000
@@ -0,0 +1,101 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#include <config.h>
+
+#include <stdio.h>
+#include <errno.h>
+#include <stdlib.h>
+
+#include "prompt.h"
+
+#include <data/file-name.h>
+#include <data/settings.h>
+#include <data/variable.h>
+#include <language/command.h>
+#include <language/lexer/lexer.h>
+#include <libpspp/alloc.h>
+#include <libpspp/assertion.h>
+#include <libpspp/message.h>
+#include <libpspp/message.h>
+#include <libpspp/str.h>
+#include <libpspp/verbose-msg.h>
+#include <libpspp/version.h>
+#include <output/table.h>
+
+/* Current prompts in each style. */
+static char *prompts[PROMPT_CNT];
+
+/* Current prompting style. */
+static enum prompt_style current_style;
+
+/* Initializes prompts. */
+void
+init_prompts (void) 
+{
+  prompts[PROMPT_FIRST] = xstrdup ("PSPP> ");
+  prompts[PROMPT_LATER] = xstrdup ("    > ");
+  prompts[PROMPT_DATA] = xstrdup ("data> ");
+  current_style = PROMPT_FIRST;
+}
+
+/* Frees prompts. */
+void
+uninit_prompts (void) 
+{
+  int i;
+
+  for (i = 0; i < PROMPT_CNT; i++) 
+    {
+      free (prompts[i]);
+      prompts[i] = NULL;
+    }
+}
+
+/* Gets the command prompt for the given STYLE. */
+const char * 
+get_prompt (enum prompt_style style)
+{
+  assert (style < PROMPT_CNT);
+  return prompts[style];
+}
+
+/* Sets the given STYLE's prompt to STRING. */
+void
+set_prompt (enum prompt_style style, const char *string)
+{
+  assert (style < PROMPT_CNT);
+  free (prompts[style]);
+  prompts[style] = xstrdup (string);
+}
+
+/* Sets STYLE as the current prompt style. */
+void
+set_prompt_style (enum prompt_style style) 
+{
+  assert (style < PROMPT_CNT);
+  current_style = style;
+}
+
+/* Returns the current prompt. */
+enum prompt_style
+get_prompt_style (void) 
+{
+  return current_style;
+}
Index: src/language/prompt.h
===================================================================
RCS file: src/language/prompt.h
diff -N src/language/prompt.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/language/prompt.h	26 Nov 2006 05:09:04 -0000
@@ -0,0 +1,44 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#ifndef PROMPT_H
+#define PROMPT_H 1
+
+#include <stdbool.h>
+
+enum prompt_style
+  {
+    PROMPT_FIRST,		/* First line of command. */
+    PROMPT_LATER,          /* Second or later line of command. */
+    PROMPT_DATA,		/* Between BEGIN DATA and END DATA. */
+    PROMPT_CNT
+  };
+
+
+void init_prompts (void);
+void uninit_prompts (void);
+
+enum prompt_style get_prompt_style (void);
+
+const char *get_prompt (enum prompt_style);
+void set_prompt (enum prompt_style, const char *);
+void set_prompt_style (enum prompt_style);
+
+
+#endif /* PROMPT_H */
Index: src/language/syntax-file.c
===================================================================
RCS file: src/language/syntax-file.c
diff -N src/language/syntax-file.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/language/syntax-file.c	26 Nov 2006 05:09:04 -0000
@@ -0,0 +1,155 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#include <config.h>
+
+#include "syntax-file.h"
+
+#include <stdio.h>
+#include <errno.h>
+#include <stdlib.h>
+
+#include <data/file-name.h>
+#include <data/settings.h>
+#include <data/variable.h>
+#include <language/command.h>
+#include <language/lexer/lexer.h>
+#include <libpspp/alloc.h>
+#include <libpspp/assertion.h>
+#include <libpspp/message.h>
+#include <libpspp/message.h>
+#include <libpspp/str.h>
+#include <libpspp/verbose-msg.h>
+#include <libpspp/version.h>
+#include <output/table.h>
+
+#include <libpspp/ll.h>
+
+#include "prompt.h"
+
+#include "gettext.h"
+#define _(msgid) gettext (msgid)
+
+#include <libpspp/getl.h>
+
+
+struct syntax_file_source 
+  {
+    struct getl_interface parent ;
+
+    FILE *syntax_file;
+
+    /* Current location. */
+    char *fn;				/* File name. */
+    int ln;				/* Line number. */
+  };
+
+static const char *
+name (const struct getl_interface *s)
+{
+  const struct syntax_file_source *sfs = (const struct syntax_file_source *) s;
+  return sfs->fn;
+}
+
+static int
+line_number (const struct getl_interface *s)
+{
+  const struct syntax_file_source *sfs = (const struct syntax_file_source *) s;
+  return sfs->ln;
+}
+
+
+/* Reads a line from syntax file source S into LINE.
+   Returns true if successful, false at end of file. */
+bool
+read_syntax_file (struct getl_interface *s, struct string *line)
+{
+  struct syntax_file_source *sfs = (struct syntax_file_source *) s;
+
+  /* Open file, if not yet opened. */
+  if (sfs->syntax_file == NULL)
+    {
+      verbose_msg (1, _("opening \"%s\" as syntax file"), sfs->fn);
+      sfs->syntax_file = fn_open (sfs->fn, "r");
+
+      if (sfs->syntax_file == NULL)
+        {
+          msg (ME, _("Opening `%s': %s."), sfs->fn, strerror (errno));
+          return false;
+        }
+    }
+
+  /* Read line from file and remove new-line.
+     Skip initial "#! /usr/bin/pspp" line. */
+  do 
+    {
+      sfs->ln++;
+      if (!ds_read_line (line, sfs->syntax_file))
+        {
+          if (ferror (sfs->syntax_file))
+            msg (ME, _("Reading `%s': %s."), sfs->fn, strerror (errno));
+          return false;
+        }
+      ds_chomp (line, '\n');
+    }
+  while (sfs->ln == 1 && !memcmp (ds_cstr (line), "#!", 2));
+
+  /* Echo to listing file, if configured to do so. */
+  if (get_echo ())
+    tab_output_text (TAB_LEFT | TAB_FIX, ds_cstr (line));
+
+  return true;
+}
+
+static void
+syntax_close (struct getl_interface *s)
+{
+  struct syntax_file_source *sfs = (struct syntax_file_source *) s;
+
+  if (sfs->syntax_file && EOF == fn_close (sfs->fn, sfs->syntax_file))
+    msg (MW, _("Closing `%s': %s."), sfs->fn, strerror (errno));
+  free (sfs->fn);
+  free (sfs);
+}
+
+static bool
+always_false (const struct getl_interface *s UNUSED)
+{
+  return false;
+}
+
+
+/* Creates a syntax file source with file name FN. */
+struct getl_interface *
+create_syntax_file_source (const char *fn) 
+{
+  struct syntax_file_source *ss = xzalloc (sizeof (*ss));
+
+  ss->fn = xstrdup (fn);
+
+  ss->parent.interactive = always_false;
+  ss->parent.read = read_syntax_file ;
+  ss->parent.filter = NULL;
+  ss->parent.close = syntax_close ;
+  ss->parent.name = name ;
+  ss->parent.location = line_number;
+
+  return (struct getl_interface *) ss;
+}
+
Index: src/language/syntax-file.h
===================================================================
RCS file: src/language/syntax-file.h
diff -N src/language/syntax-file.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/language/syntax-file.h	26 Nov 2006 05:09:04 -0000
@@ -0,0 +1,37 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#if !LB_SYNTAX
+#define LB_SYNTAX 1
+
+#include <stdbool.h>
+
+struct string;
+struct getl_interface;
+struct getl_source;
+
+
+bool read_syntax_file (struct getl_interface *s, struct string *line);
+
+
+/* Creates a syntax file source with file name FN. */
+struct getl_interface * create_syntax_file_source (const char *fn) ;
+
+
+#endif
Index: src/language/control/automake.mk
===================================================================
RCS file: /sources/pspp/pspp/src/language/control/automake.mk,v
retrieving revision 1.2
diff -b -w -U3 -r1.2 automake.mk
--- src/language/control/automake.mk	15 Mar 2006 03:29:10 -0000	1.2
+++ src/language/control/automake.mk	26 Nov 2006 05:09:04 -0000
@@ -10,5 +10,7 @@
 	src/language/control/loop.c \
 	src/language/control/temporary.c \
 	src/language/control/repeat.c \
-	src/language/control/repeat.h
+	src/language/control/repeat.h \
+	src/language/control/function.h \
+	src/language/control/function.c
 
Index: src/language/control/function.c
===================================================================
RCS file: src/language/control/function.c
diff -N src/language/control/function.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/language/control/function.c	26 Nov 2006 05:09:04 -0000
@@ -0,0 +1,120 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#include "function.h"
+#include <libpspp/getl.h>
+#include <libpspp/compiler.h>
+#include <libpspp/alloc.h>
+
+#include <stdlib.h>
+
+struct function_source
+  {
+    struct getl_interface parent ;  
+
+    int ln; 
+    char *fn;
+
+    void (*filter) (struct string *, void *aux);
+        bool (*read) (struct string *line, char **fn, int *ln, void *aux);
+    void (*close) (void *aux);
+    void *aux;
+  };
+
+
+static const char *
+name (const struct getl_interface *s)
+{
+  const struct function_source *f = (const struct function_source *) s;
+  
+  return f->fn;
+}
+
+
+static int
+line_number (const struct getl_interface *s)
+{
+  const struct function_source *f = (const struct function_source *) s;
+  
+  return f->ln;
+}
+
+
+
+
+static bool
+read_function (struct getl_interface *s, struct string *line)
+{
+  struct function_source *f = (struct function_source *) s;
+
+  return f->read (line, &f->fn, &f->ln, f->aux);
+}
+
+static void
+function_close (struct getl_interface *s)
+{
+  struct function_source *f = (struct function_source *) s;
+
+  if (f->close != NULL)
+    f->close (f->aux);
+
+  free (f);
+}
+
+static bool
+always_false (const struct getl_interface *s UNUSED)
+{
+  return false;
+}
+
+static void  
+function_filter (struct getl_interface *s, struct string *line)
+{
+  struct function_source *f = (struct function_source *) s;
+
+  f->filter (line, f->aux);
+}
+
+
+/* Creates a function source with the given READ and CLOSE
+   functions that receive auxiliary data AUX. */
+struct getl_interface *
+create_function_source (bool (*read) (struct string *line,
+                                      char **fn, int *ln, void *aux),
+			void (*filter) (struct string *, void *aux),
+                        void (*close) (void *aux),
+                        void *aux)
+{
+  struct function_source *f = xzalloc ( sizeof *f);
+
+  f->read = read;
+  f->close = close;
+  f->aux = aux;
+  f->filter = filter;
+
+  f->parent.interactive = always_false;
+  f->parent.read = read_function;
+  f->parent.filter = filter ? function_filter : NULL;
+  f->parent.close = function_close;
+  f->parent.name = name;
+  f->parent.location = line_number;
+  
+  return (struct getl_interface *) f;
+}
+
Index: src/language/control/function.h
===================================================================
RCS file: src/language/control/function.h
diff -N src/language/control/function.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/language/control/function.h	26 Nov 2006 05:09:04 -0000
@@ -0,0 +1,36 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#if !LB_FUNCTION
+#define LB_FUNCTION 1
+
+#include  <stdbool.h>
+
+
+struct string;
+struct getl_interface;
+
+struct getl_interface *
+create_function_source ( bool (*read) (struct string *line,
+                                      char **fn, int *ln, void *aux),
+			void (*filter) (struct string *, void *aux),
+                        void (*close) (void *aux),
+                        void *aux);
+
+#endif
Index: src/language/control/repeat.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/control/repeat.c,v
retrieving revision 1.15
diff -b -w -U3 -r1.15 repeat.c
--- src/language/control/repeat.c	11 Nov 2006 23:10:00 -0000	1.15
+++ src/language/control/repeat.c	26 Nov 2006 05:09:05 -0000
@@ -25,16 +25,17 @@
 #include <math.h>
 #include <stdlib.h>
 
+#include "function.h"
+
 #include <data/dictionary.h>
 #include <data/procedure.h>
 #include <data/settings.h>
+#include <libpspp/getl.h>
 #include <language/command.h>
 #include <language/lexer/lexer.h>
 #include <language/lexer/variable-parser.h>
-#include <language/line-buffer.h>
 #include <libpspp/alloc.h>
 #include <libpspp/message.h>
-#include <libpspp/message.h>
 #include <libpspp/misc.h>
 #include <libpspp/pool.h>
 #include <libpspp/str.h>
@@ -111,8 +112,12 @@
   
   block->cur_line = NULL;
   block->loop_idx = -1;
-  getl_include_filter (do_repeat_filter, do_repeat_close, block);
-  getl_include_function (do_repeat_read, NULL, block);
+
+  getl_include_source 
+    ( create_function_source (do_repeat_read, 
+			      do_repeat_filter, 
+			      do_repeat_close, block)
+      );
 
   return CMD_SUCCESS;
 
@@ -147,7 +152,8 @@
       for (iter = block->macros; iter != NULL; iter = iter->next)
 	if (!strcasecmp (iter->id, lex_tokid (lexer)))
 	  {
-	    msg (SE, _("Dummy variable name \"%s\" is given twice."), lex_tokid (lexer));
+	    msg (SE, _("Dummy variable name \"%s\" is given twice."), 
+		 lex_tokid (lexer));
 	    return false;
 	  }
 
@@ -278,8 +284,8 @@
 
   for (;;)
     {
-      const char *cur_file_name;
-      int cur_line_number;
+      const char *cur_file_name = getl_source_name ();
+      int cur_line_number = getl_source_location ();
       struct line_list *line;
       struct string cur_line_copy;
       bool dot;
@@ -288,7 +294,6 @@
         return false;
 
       /* If the current file has changed then record the fact. */
-      getl_location (&cur_file_name, &cur_line_number);
       if (previous_file_name == NULL 
           || !strcmp (cur_file_name, previous_file_name))
         previous_file_name = pool_strdup (block->pool, cur_file_name);
Index: src/language/data-io/data-reader.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/data-io/data-reader.c,v
retrieving revision 1.17
diff -b -w -U3 -r1.17 data-reader.c
--- src/language/data-io/data-reader.c	22 Nov 2006 04:24:02 -0000	1.17
+++ src/language/data-io/data-reader.c	26 Nov 2006 05:09:05 -0000
@@ -32,7 +32,7 @@
 #include <language/command.h>
 #include <language/data-io/file-handle.h>
 #include <language/lexer/lexer.h>
-#include <language/line-buffer.h>
+#include <language/prompt.h>
 #include <libpspp/alloc.h>
 #include <libpspp/assertion.h>
 #include <libpspp/message.h>
@@ -169,7 +169,7 @@
         lex_get (r->lexer);
       if (!lex_force_match_id (r->lexer, "BEGIN") || !lex_force_match_id (r->lexer, "DATA"))
         return false;
-      getl_set_prompt_style (GETL_PROMPT_DATA);
+      set_prompt_style (PROMPT_DATA);
     }
       
   if (!lex_get_line_raw (r->lexer))
@@ -444,7 +444,7 @@
   r->flags |= DFM_SAW_BEGIN_DATA;
 
   /* Input procedure reads from inline file. */
-  getl_set_prompt_style (GETL_PROMPT_DATA);
+  set_prompt_style (PROMPT_DATA);
   ok = procedure (ds, NULL, NULL);
 
   dfm_close_reader (r);
Index: src/language/data-io/file-handle.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/data-io/file-handle.q,v
retrieving revision 1.9
diff -b -w -U3 -r1.9 file-handle.q
--- src/language/data-io/file-handle.q	11 Nov 2006 23:10:00 -0000	1.9
+++ src/language/data-io/file-handle.q	26 Nov 2006 05:09:05 -0000
@@ -26,7 +26,6 @@
 #include <data/file-name.h>
 #include <language/command.h>
 #include <language/lexer/lexer.h>
-#include <language/line-buffer.h>
 #include <libpspp/assertion.h>
 #include <libpspp/message.h>
 #include <libpspp/magic.h>
Index: src/language/lexer/lexer.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/lexer/lexer.c,v
retrieving revision 1.13
diff -b -w -U3 -r1.13 lexer.c
--- src/language/lexer/lexer.c	14 Nov 2006 12:29:25 -0000	1.13
+++ src/language/lexer/lexer.c	26 Nov 2006 05:09:05 -0000
@@ -30,9 +30,9 @@
 #include <libpspp/assertion.h>
 #include <language/command.h>
 #include <libpspp/message.h>
-#include <language/line-buffer.h>
 #include <libpspp/magic.h>
 #include <data/settings.h>
+#include <libpspp/getl.h>
 #include <libpspp/str.h>
 
 #include "size_max.h"
Index: src/language/utilities/include.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/utilities/include.c,v
retrieving revision 1.6
diff -b -w -U3 -r1.6 include.c
--- src/language/utilities/include.c	11 Nov 2006 23:10:00 -0000	1.6
+++ src/language/utilities/include.c	26 Nov 2006 05:09:05 -0000
@@ -23,9 +23,12 @@
 #include <libpspp/alloc.h>
 #include <language/command.h>
 #include <libpspp/message.h>
-#include <language/line-buffer.h>
+#include <libpspp/getl.h>
+#include <language/syntax-file.h>
 #include <language/lexer/lexer.h>
 #include <libpspp/str.h>
+#include <data/file-name.h>
+
 
 #include "gettext.h"
 #define _(msgid) gettext (msgid)
@@ -33,6 +36,9 @@
 int
 cmd_include (struct lexer *lexer, struct dataset *ds UNUSED)
 {
+  char *found_fn;
+  char *target_fn;
+
   /* Skip optional FILE=. */
   if (lex_match_id (lexer, "FILE"))
     lex_match (lexer, '=');
@@ -43,7 +49,21 @@
       lex_error (lexer, _("expecting file name")); 
       return CMD_CASCADING_FAILURE;
     }
-  getl_include_syntax_file (ds_cstr (lex_tokstr (lexer)));
+
+  target_fn = ds_cstr (lex_tokstr (lexer));
+
+  found_fn = fn_search_path (target_fn,
+			     getl_include_path (),
+			     NULL);
+
+  if (found_fn != NULL) 
+    {
+      getl_include_source (create_syntax_file_source (found_fn));
+      free (found_fn); 
+    }
+  else
+    msg (SE, _("Can't find `%s' in include file search path."), 
+	 target_fn);
 
   lex_get (lexer);
   return lex_end_of_command (lexer);
Index: src/language/utilities/set.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/utilities/set.q,v
retrieving revision 1.20
diff -b -w -U3 -r1.20 set.q
--- src/language/utilities/set.q	22 Nov 2006 04:24:03 -0000	1.20
+++ src/language/utilities/set.q	26 Nov 2006 05:09:05 -0000
@@ -34,7 +34,7 @@
 #include <language/command.h>
 #include <language/lexer/format-parser.h>
 #include <language/lexer/lexer.h>
-#include <language/line-buffer.h>
+#include <language/prompt.h>
 #include <libpspp/alloc.h>
 #include <libpspp/compiler.h>
 #include <libpspp/copyleft.h>
@@ -152,11 +152,11 @@
     do_cc (cmd.s_cce, FMT_CCE);
 
   if (cmd.sbc_prompt)
-    getl_set_prompt (GETL_PROMPT_FIRST, cmd.s_prompt);
+    set_prompt (PROMPT_FIRST, cmd.s_prompt);
   if (cmd.sbc_cprompt)
-    getl_set_prompt (GETL_PROMPT_LATER, cmd.s_cprompt);
+    set_prompt (PROMPT_LATER, cmd.s_cprompt);
   if (cmd.sbc_dprompt)
-    getl_set_prompt (GETL_PROMPT_DATA, cmd.s_dprompt);
+    set_prompt (PROMPT_DATA, cmd.s_dprompt);
 
   if (cmd.sbc_decimal)
     fmt_set_decimal (cmd.dec == STC_DOT ? '.' : ',');
Index: src/libpspp/automake.mk
===================================================================
RCS file: /sources/pspp/pspp/src/libpspp/automake.mk,v
retrieving revision 1.15
diff -b -w -U3 -r1.15 automake.mk
--- src/libpspp/automake.mk	28 Oct 2006 04:01:55 -0000	1.15
+++ src/libpspp/automake.mk	26 Nov 2006 05:09:05 -0000
@@ -25,6 +25,10 @@
 	src/libpspp/i18n.h \
 	src/libpspp/integer-format.c \
 	src/libpspp/integer-format.h \
+	src/libpspp/getl.h \
+	src/libpspp/getl.c \
+	src/libpspp/msg-locator.c \
+	src/libpspp/msg-locator.h \
 	src/libpspp/ll.c \
 	src/libpspp/ll.h \
 	src/libpspp/llx.c \
